unit AHCI;

interface

uses 
    util,
    PCI,
    drivertypes,
    drivermanagement,
    lmemorymanager,
    console,
    vmemorymanager,
    AHCITypes;

var
    ahciControllers : array[0..255] of pointer;
    ahciControllerCount : uint32;
    
    hba : array[0..255] of THBA_Memory;

procedure init();
procedure load();

implementation

procedure init();
var
    devID : TDeviceIdentifier;
begin
    console.writestringln('AHCI: Registering driver');
    devID.bus:= biPCI;
    devID.id0:= idANY;
    devID.id1:= $00000001;
    devID.id2:= $00000006;
    devID.id3:= $00000001;
    devID.id4:= idANY;
    devID.ex:= nil;
    drivermanagement.register_driver('ATA/PI AHCI Driver', @devID, @load);
end;

procedure load(ptr : void);
begin
    // console.writestringln('AHCI: initilizing a new controller');
    // ahciControllers[ahciControllerCount] := ptr;
    // hba[ahciControllerCount] := PPCI_Device(ptr)^.address5;
    // new_page_at_address(hba[ahciControllerCount]);

    // //here would be any controller setup needed

    // check_ports(ahciControllerCount);
    // ahciControllerCount += 1;
    // exit(true);
end;


end.
